-- Shoot-able grenades by MikuAuahDark
ShotGren=ShotGren or {}

-- User Configuration
ShotGren.Berhaviour={
	-- This table allows you to configure custom berhaviour if grenade/projectile objects get shoot
	-- Function below which have [89] is for satchel charge. Because satchel charge ID is 89
	-- Format: [weapon_id_type]=custom_berhaviour_function(player_id,projectile_id)
	[89]=function(id,pid)	-- id = player id, pid = projectile id
		local x,y=projectile(pid,id,"x"),projectile(pid,id,"y")
		parse("freeprojectile "..pid.." "..id)
		parse("explosion "..x.." "..y.." 150 100 "..id)
	end
}
-- End UConfig
ShotGren.Projectiles={47,48,49,51,52,53,54,72,73,75,86,89}
ShotGren.Hitzones={}		-- Format: ["id|projectile_id"]=image_id

fai_contains=fai_contains or function(t,e)
	for _, value in pairs(t) do
		if value == e then
			return true
		end
	end
	return false
end

function ShotGren.Always()
	for n,v in pairs(projectilelist(1,0)) do
		if ShotGren.Hitzones[v.player.."|"..v.id] then
			freeimage(ShotGren.Hitzones[v.player.."|"..v.id])
			ShotGren.Hitzones[v.player.."|"..v.id]=nil
		end
	end
	for n,v in pairs(projectilelist(0,0)) do
		if not ShotGren.Hitzones[v.player.."|"..v.id] and fai_contains(ShotGren.Projectiles,projectile(v.id,v.player,"type")) and projectile(v.id,v.player,"flydist")>1 then
			local temp=image("gfx/10x10.bmp",projectile(v.id,v.player,"x"),projectile(v.id,v.player,"y"),1)
			ShotGren.Hitzones[v.player.."|"..v.id]=temp
			imagehitzone(temp,102)
			imagealpha(temp,0)
		elseif ShotGren.Hitzones[v.player.."|"..v.id] then
			imagepos(ShotGren.Hitzones[v.player.."|"..v.id],projectile(v.id,v.player,"x"),projectile(v.id,v.player,"y"),0)
		end
	end
end

function ShotGren.Hitzone(image_id)
	for n,v in pairs(ShotGren.Hitzones) do
		if v==image_id then
			local owner_id,projectile_id=n:match("(%d+)|(%d+)")
			owner_id=tonumber(owner_id)
			projectile_id=tonumber(projectile_id)
			local weapon_id=projectile(projectile_id,owner_id,"type")
			local x,y=projectile(projectile_id,owner_id,"x"),projectile(projectile_id,owner_id,"y")
			if ShotGren.Berhaviour[weapon_id] then
				ShotGren.Berhaviour[weapon_id](owner_id,projectile_id)
			else
				parse("freeprojectile "..projectile_id.." "..owner_id)
				parse("spawnprojectile "..owner_id.." "..weapon_id.." "..x.." "..y.." 1 0")
			end
			freeimage(v)
		end
	end
end

addhook("always","ShotGren.Always")
addhook("hitzone","ShotGren.Hitzone")